(defun get.bitstring (bitstring.length varlist) (let(
(i 0)(j 0)(bitstring nil) (number 0) (bit.to.add nil))
; varlist is a list of the form #(arg1, arg2, arg3... argn)
; bitstring.length is the length of the bitstring created. automatically calculated if 0.
(if (= bitstring.length 0) (let() 
(loop (let()
(if (= (length varlist) i) (return))
(setq i (+ i 2))
(setq bitstring.length (+ bitstring.length (at varlist i)))
)) ;loop
)) ;end if
(setq bitstring (make-array (cons bitstring.length nil):element-type 'bit :initial-element 0))
(setq i 0) (loop (let()
(if (= (length varlist) i) (return))
(setq number (aref varlist i))
(loop for cur.bit.pos from 0 to (- (aref varlist (+ 1 i)) 1) do(let()
(setq bit.to.add (logbitp cur.bit.pos number))
(if bit.to.add (setf (bit bitstring (+ cur.bit.pos j)) 1) (setf (bit bitstring (+ cur.bit.pos j)) 0))
)) ;loop
(setq j (+ j (aref varlist (+ 1 i))))
(setq i (+ i 2))
)) ;loop
bitstring
)) ;end get.bitstring

(defun create.random.bitstring (tot.length) (let((loc1 0) (bitstring 0))
(setq bitstring (make-array (cons tot.length nil):element-type 'bit :initial-element 0))
(loop for i from 1 to (/ (* array.noise tot.length) 100) do(let()
(setq loc1 (random tot.length))
(setf (bit bitstring loc1) (- 1 (aref bitstring loc1)))
)) ;loop
bitstring
)) ;end create.random.bitstring

(defun add.bitstring.noise (bitstring &optional (bitstring.length (length bitstring))) (let((loc1 0) (bit1 0))
(loop for i from 1 to (/ (* array.noise bitstring.length) 100) do(let()
(setq loc1 (random bitstring.length))
(setq bit1 (aref bitstring loc1))
(setf (bit bitstring loc1) (- 1 bit1))
)) ;loop
bitstring
)) ;end add.bitstring.noise

(defun antstring.at (cur.index cur.loc) (let()
(bit antstring (+ (* antstring.length (- cur.index 1)) cur.loc -1))
)) ;end antstring.at

(defun antstring= (cur.index cur.loc set.val) (let()
(setf (bit antstring (+ (* antstring.length (- cur.index 1)) cur.loc -1)) set.val)
)) ;end antstring=

(defun create.genestring () (let()
(setq genestring (create.random.bitstring (* genestring.length gene.amount evo.ant.amount)))
)) ;end create.genestring

(defun genestring.at (cur.loc1 cur.loc2 cur.loc3) (let()
(bit genestring
(+ (* (- cur.loc1 1) gene.amount genestring.length)
(* (- cur.loc2 1) genestring.length)
(- cur.loc3 1)))
)) ;end genestring.at

(defun genestring= (cur.loc1 cur.loc2 cur.loc3 set.val) (let()
(setf (bit genestring
(+ (* (- cur.loc1 1) gene.amount genestring.length)
(* (- cur.loc2 1) genestring.length)
(- cur.loc3 1))) set.val)
)) ;end genestring=

(defun copy.ant (ant1 ant2) (let()
(loop for i from 0 to (- gene.amount 1) do(let()
(loop for j from 0 to (- genestring.length 1) do(let()
(setf
(bit genestring (+ (* ant1 gene.amount genestring.length) (* i genestring.length) j))
(bit genestring (+ (* ant2 gene.amount genestring.length) (* i genestring.length) j)))
)))) ;next j, i
temp.ant
)) ;end copy.ant

(defun print.antstring (temp.ant.index) (let((i 0)(j 0)(i2 0))
(setq temp.ant.index (- temp.ant.index 1))
(setq temp.ant (make-array (cons (* gene.amount genestring.length) nil):element-type 'bit :initial-element 0))
(loop for i from 0 to (- gene.amount 1) do(let()
(loop for j from 0 to (- genestring.length 1) do(let()
(setf (bit temp.ant (+ (* genestring.length i) j)) (bit genestring (+ (* temp.ant.index gene.amount genestring.length) (* i genestring.length) j)))
)))) ;next j, i
temp.ant
))