;; All Material Copyright (C) Agamemnus -- warlordagamemnus@aol.com (Michael Romanovsky)

;; begin string/number-manipulation function list

(lw:set-default-character-element-type 'base-char)

(defun <> (a b) (let((val 0))
(if (typep a 'string) (setq val (not (equalp a b))))
(if (typep a 'integer) (setq val (/= a b)))
val
)) ;end <>

(defun +str ( &rest a) (let((b ""))
(loop (let()
(if (equalp a nil) (return))
(setq b (concatenate 'string b (car a)))
(setq a (cdr a))
)) ;loop
b
)) ;end str

(defun len (x) (length x))
(defun right$ (x a) (subseq x (- (length x) a) (length x)))
(setq charstring "                                                 ! #$%&'()*+,-./@ABCDEFGHIJKLMNOPQRSTUVWXYZ[ ]^_'abcdefghijklmnopqrstuvwxyz{|}~")
(setq alphastring "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz")

(setq space " ")
(defun chr$ (a) (subseq charstring a (+ a 1)))

(defun asc (a) (let((j 0))
(loop for i from 1 to (length charstring) do (let()
(if (equalp (subseq charstring i (+ i 1)) a) (let() (setq j i) (loop-finish) ))
)) ;next i
j
)) ;end asc

(defun mid$ (x a &optional (b 1)) (let()
(subseq x (- a 1) (- (+ a b) 1))
)) ;end mid

(defun str$(n) (let(
(neg "")
)
(if (<> (denominator n) 1) (+str (str$ (numerator n)) (+str "/" (str$ (denominator n))))
(let() ;else
(if (< n 0) (let() (setq neg "-") (setq n (* n -1))))
(if (<= n 9) (let()
(+str neg (str2$ n))
)(let() ;else
(+str neg (str$ (/ (- n (mod n 10)) 10)) (str2$ (mod n 10)))
)) ;end if
)) ;end if
)) ;end str$

(defun str2$ (n) (let()
(case n
(0 "0") (1 "1") (2 "2") (3 "3") (4 "4") (5 "5") (6 "6") (7 "7") (8 "8") (9 "9")
) ;end select
)) ;end str2$


(defun instr (string.to.be.searched string.to.look.for &optional (start 1))
(let(
(i 0) (k 0) (s1 "") (s2 "") (end.loop1 0) (length.string.to.look.for 0)
)
(setq length.string.to.look.for (length string.to.look.for))
(setq end.loop1 (+ (- (length string.to.be.searched) length.string.to.look.for) 1))
(loop for i from start to end.loop1 do (let()
(setq k i)
(loop for j from 1 to length.string.to.look.for do (let()
(setq s1 (mid$ string.to.be.searched (- (+ i j) 1) 1))
(setq s2 (mid$ string.to.look.for j 1))
(if (<> s1 s2) (let() (setq k 0) (loop-finish) ))
)) ;next j
(if (<> k 0) (loop-finish))
)) ;next i
k
)) ;end instr

(defun val(n) (let((neg 1) (div.s (instr n "/")) )
(if (<> div.s 0)
(/ (val (mid$ n 1 (- div.s 1))) (val (mid$ n (+ div.s 1) (- (length n) div.s))))
(let(); else
(if (equalp (mid$ n 1) "-")
(let()
(setq neg -1)
(setq n (mid$ n 2 (- (length n) 1)))
)) ;end if
(if (= (length n) 1)
(* neg (val2 n))
(* neg (+ (* 10 (val (subseq n 0 (- (length n) 1)))) (val2 (right$ n 1)))
)) ;end if
)) ;end if
)) ;end val

(defun val2 (n) (let()
(if (equalp n "0") 0
(if (equalp n "1") 1
(if (equalp n "2") 2
(if (equalp n "3") 3
(if (equalp n "4") 4 
(if (equalp n "5") 5
(if (equalp n "6") 6
(if (equalp n "7") 7
(if (equalp n "8") 8
(if (equalp n "9") 9
))))))))))
)) ;end val2

(defun replace.string (cur.string string.to.replace pos1 pos2) (let((string1a "") (string1b ""))
(setq string1a (mid$ cur.string 1 (- pos1 1)))
(setq string1b (mid$ cur.string (+ pos2 1) (- (length cur.string) pos2)))
(+str string1a string.to.replace string1b)
)) ;end replace.string

(setq space " ")

;; begin lazy-type function list

(defun dim1 (x a) (setq x (make-array (cons a nil):initial-element 0)))
(defun dim2 (x a b) (setq x (make-array (cons a (cons b nil)):initial-element 0)))
(defun dim3 (x a b c) (setq x (make-array (cons a (cons b (cons c nil))):initial-element 0)))
(defun =1 (x a v) (setf (aref x (- a 1)) v))
(defun =2 (x a b v) (setf (aref x (- a 1) (- b 1)) v))
(defun =3 (x a b c v) (setf (aref x (- a 1) (- b 1) (- c 1)) v))
(defun at1 (x a) (aref x (- a 1)))
(defun at2 (x a b) (aref x (- a 1) (- b 1)))
(defun at3 (x a b c) (aref x (- a 1) (- b 1) (- c 1)))

(defun dim (x a &optional (b 0) (c 0)) (let()
(if (= c 0)
(if (= b 0)
(setq x (make-array (cons a nil):initial-element 0))
(setq x (make-array (cons a (cons b nil)):initial-element 0))
) ;end if
(setq x (make-array (cons a (cons b (cons c nil))):initial-element 0))
) ;end if
)) ;end dim

(defun =a (x a b &optional (c nil) (d nil)) (let()
(if (not (equalp c nil))
(if (not (equalp d nil))
(setf (aref x (- a 1) (- b 1) (- c 1)) d)
(setf (aref x (- a 1) (- b 1)) c)
) ;end if
(setf (aref x (- a 1)) b)
) ;end if
)) ;end =a

(defun at (x a &optional (b 0) (c 0)) (let()
(if (= c 0)
(if (= b 0)
(aref x (- a 1))
(aref x (- a 1) (- b 1))
) ;end if
(aref x (- a 1) (- b 1) (- c 1))
) ;end if
)) ;end at
